---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "notificationservice.fullname" . }}
  labels:
    {{- include "notificationservice.labels" . | nindent 4 }}
spec:
  {{- if not .Values.autoscaling.enabled }}
  replicas: {{ .Values.replicaCount }}
  {{- end }}
  selector:
    matchLabels:
      {{- include "notificationservice.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      labels:
        {{- include "notificationservice.selectorLabels" . | nindent 8 }}
    spec:
      enableServiceLinks: false
      automountServiceAccountToken: false
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}:{{ coalesce .Values.image.tag .Values.global.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: "{{ coalesce .Values.image.pullPolicy .Values.global.image.pullPolicy }}"
          ports:
            - name: http
              containerPort: 8000
              protocol: TCP
            - name: metrics
              containerPort: 9000
              protocol: TCP
          startupProbe:
            httpGet:
              path: /healthcheck
              port: http
            periodSeconds: 10
            failureThreshold: 60
          livenessProbe:
            httpGet:
              path: /healthcheck
              port: http
            periodSeconds: 10
          readinessProbe:
            httpGet:
              path: /healthcheck
              port: http
            periodSeconds: 10
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
          env:
            - name: Logging__LogLevel__Default
              value: {{ include "getDotNetLogLevel" (coalesce .Values.log_level .Values.global.log_level | upper) }}
            - name: Logging__LogLevel__Microsoft.AspNetCore
              value: {{ include "getDotNetLogLevel" (coalesce .Values.log_level .Values.global.log_level | upper) }}
            - name: Logging__LogLevel__Grpc
              value: {{ include "getDotNetLogLevel" (coalesce .Values.log_level .Values.global.log_level | upper) }}
            {{- if .Values.global.rabbitmq.enabled }}
            - name: HHB_RABBITMQ_HOST
              valueFrom:
                secretKeyRef:
                  name: {{ printf "%s-rabbitmq" .Release.Name }}
                  key: host
            - name: HHB_RABBITMQ_PORT
              valueFrom:
                secretKeyRef:
                  name: {{ printf "%s-rabbitmq" .Release.Name }}
                  key: port
            - name: HHB_RABBITMQ_USER
              valueFrom:
                secretKeyRef:
                  name: {{ printf "%s-rabbitmq" .Release.Name }}
                  key: username
            - name: HHB_RABBITMQ_PASS
              valueFrom:
                secretKeyRef:
                  name: {{ printf "%s-rabbitmq" .Release.Name }}
                  key: password
            {{- end }}
            {{- if .Values.extraEnvVars }}{{- toYaml .Values.extraEnvVars | nindent 12 }}{{- end }}
